//
//  Enemy.m
//  SimpleShot
#import "global.h"
#import "Enemy.h"


@implementation Enemy

/** 적기 타입과 이미지를 설정 */
- (id)initWithImage:(NSImage*)img
		   type:(int)t
{
	[super init];
	
	type = t;
	
	image = img;

	return self;
}

- (void)setPosition:(NSPoint)pos
{
	position = pos;
}

- (int)state
{
	return state;
}

- (void)setState:(int)s
{
	state = s;
}

/** 적기를 한단계 아래로 옮기고, 화면에 안 나올 경우에는 상태를 0으로 변경한다. */
- (void)down
{
	position.y -= ENEMY_DOWN;
	if(position.y + [image size].height < 0)
		state = 0;
}

- (BOOL)moveAndDisplay:(int)dir
{
	BOOL isChange = false;
	NSRect drawRect;
	NSRect imgRect;
		
	drawRect.size = [image size];
	
	/** 적기를 이동하고 좌우 화면의 경계를 넘었을 경우에는 아래로 이동하도록 isChange를 1로 세팅 해서 반환. */ 
	position.x += dir;
	if(position.x < 0)
	{
		isChange = true;
	}	
	if(position.x >= SCREEN_WIDTH - drawRect.size.width)
	{
		isChange = true;
	}
	
	/** 적기를 출력한다. */
	drawRect.origin.x = position.x;
	drawRect.origin.y = position.y;
	
	imgRect.origin = NSZeroPoint;
    imgRect.size = [image size];
	
    [image drawInRect:drawRect
					   fromRect:imgRect
					  operation:NSCompositeSourceOver
					   fraction:1.0];	
	
	return isChange;
}


@end
